#include <iostream>
#include <string>
#include <boost/interprocess/managed_shared_memory.hpp>
#include <cstdlib> //std::system
#include <sstream>

using namespace std;
using namespace boost;
using namespace boost::interprocess;

//	const data
const char * MMMAP_NAME = "MySharedMemory";
int max_share_size = 65536;
int real_share_size = 1024;

int main (int argc, char *argv[])
{
	if(argc == 1){ 
		shared_memory_object::remove(MMMAP_NAME);
		// Create a managed shared memory segment
		managed_shared_memory segment(create_only, MMMAP_NAME, max_share_size);

		// Allocate a portion of the segment (raw memory)
		std::size_t free_memory = segment.get_free_memory();
		void * shptr = segment.allocate(real_share_size);

		// Check invariant
		if(free_memory > segment.get_free_memory()){

			char *pbuff=(char *)shptr;
			pbuff[0]='A';
			pbuff[1]='B';
			pbuff[2]='C';
			pbuff[3]=NULL;

			// convert memory to handle
			managed_shared_memory::handle_t handle = segment.get_handle_from_address(shptr);
			// set of child process param .
			std::stringstream s;
			s << argv[0] << " " << handle;
			s << std::ends;
			cout << "handle:"  << handle << endl;
			// Launch child process
			int nchild = std::system(s.str().c_str());

			cout << "child return:"  << nchild << endl;
			cout << "changed?:"<< pbuff << endl;

			//	delete share memory
			segment.deallocate(pbuff);

			string sdata;
			cin >> sdata ;	//	any key input!! -> exit.

			//	delete share memory
			shared_memory_object::remove(MMMAP_NAME);

		} else {
			//	delete share memory
			shared_memory_object::remove(MMMAP_NAME);

			return 1;
		}
	} else {
		//Open managed segment
		managed_shared_memory segment(open_only, MMMAP_NAME);

		//An handle from the base address can identify any byte of the shared 
		//memory segment even if it is mapped in different base addresses
		managed_shared_memory::handle_t handle = 0;

		//Obtain handle value
		std::stringstream s; s << argv[1]; s >> handle;

		// Get buffer local address from handle
		void *msg = segment.get_address_from_handle(handle);

		char *pbuff=(char *)msg;

		cout << "origin:" << pbuff << endl;

		//	change data!!
		pbuff[0]='D';
		pbuff[1]='E';
		pbuff[2]='F';
		pbuff[3]=NULL;

	}
	return 0;
}
